Subject: bug#33255: 27.0.50; expand-file-name: default directory expanded twice if relative

From: Eli Zaretskii <[email-masked]>
Date: Tue, 13 Nov 2018 22:12:59 +0200

> From: Paul Eggert <[email-masked]>
> Date: Tue, 13 Nov 2018 10:26:43 -0800
> Cc: [email-masked], immerrr again <[email-masked]>,
> 	Noam Postavsky <[email-masked]>
> 
> > I think a non-absolute HOME is a user error.
> > Eg cd $HOME may then not be idempotent.
> That's true. However, POSIX says that sh treats ~/foo like $HOME/foo 
> even when HOME is not absolute, and it's better if Emacs is consistent 
> with POSIX as much as possible within the Emacs constraint that 
> expand-file-name must expand to an absolute file name. So I implemented 
> something along the line of Noam's suggestion by installing the attached 
> patch into master; this should fix the bug originally reported.
> 
> Unlike Noam's suggestion, this patch causes Emacs to look at the current 
> value of HOME, not the value HOME had when Emacs started up, as that 
> corresponds more closely to POSIX sh.

Thanks.  I think this needs to be called out in NEWS as an
incompatible change, and probably also documented in the manuals.